@REM ----------------------------------------------------------------------------
@REM Copyright 2001-2004 The Apache Software Foundation.
@REM
@REM Licensed under the Apache License, Version 2.0 (the "License");
@REM you may not use this file except in compliance with the License.
@REM You may obtain a copy of the License at
@REM
@REM      http://www.apache.org/licenses/LICENSE-2.0
@REM
@REM Unless required by applicable law or agreed to in writing, software
@REM distributed under the License is distributed on an "AS IS" BASIS,
@REM WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
@REM See the License for the specific language governing permissions and
@REM limitations under the License.
@REM ----------------------------------------------------------------------------
@REM

@echo off

set ERROR_CODE=0

:init
@REM Decide how to startup depending on the version of windows

@REM -- Win98ME
if NOT "%OS%"=="Windows_NT" goto Win9xArg

@REM set local scope for the variables with windows NT shell
if "%OS%"=="Windows_NT" @setlocal

@REM -- 4NT shell
if "%eval[2+2]" == "4" goto 4NTArgs

@REM -- Regular WinNT shell
set CMD_LINE_ARGS=%*
goto WinNTGetScriptDir

@REM The 4NT Shell from jp software
:4NTArgs
set CMD_LINE_ARGS=%$
goto WinNTGetScriptDir

:Win9xArg
@REM Slurp the command line arguments.  This loop allows for an unlimited number
@REM of arguments (up to the command line limit, anyway).
set CMD_LINE_ARGS=
:Win9xApp
if %1a==a goto Win9xGetScriptDir
set CMD_LINE_ARGS=%CMD_LINE_ARGS% %1
shift
goto Win9xApp

:Win9xGetScriptDir
set SAVEDIR=%CD%
%0\
cd %0\..\.. 
set BASEDIR=%CD%
cd %SAVEDIR%
set SAVE_DIR=
goto repoSetup

:WinNTGetScriptDir
set BASEDIR=%~dp0\..

:repoSetup


if "%JAVACMD%"=="" set JAVACMD=java

if "%REPO%"=="" set REPO=%BASEDIR%\lib

set CLASSPATH="%BASEDIR%"\conf;"%REPO%"\scm-server-1.33-SNAPSHOT.jar;"%REPO%"\commons-daemon-1.0.10.jar;"%REPO%"\jetty-server-7.6.11.v20130520.jar;"%REPO%"\javax.servlet-2.5.0.v201103041518.jar;"%REPO%"\jetty-continuation-7.6.11.v20130520.jar;"%REPO%"\jetty-http-7.6.11.v20130520.jar;"%REPO%"\jetty-io-7.6.11.v20130520.jar;"%REPO%"\jetty-webapp-7.6.11.v20130520.jar;"%REPO%"\jetty-xml-7.6.11.v20130520.jar;"%REPO%"\jetty-servlet-7.6.11.v20130520.jar;"%REPO%"\jetty-security-7.6.11.v20130520.jar;"%REPO%"\jetty-jmx-7.6.11.v20130520.jar;"%REPO%"\jetty-util-7.6.11.v20130520.jar;"%REPO%"\jetty-ajp-7.6.11.v20130520.jar
set EXTRA_JVM_ARGUMENTS=-Djava.awt.headless=true -Dlogback.configurationFile=logging.xml
goto endInit

@REM Reaching here means variables are defined and arguments have been captured
:endInit

set PRUNSRV=prunsrv.exe
if "%PROCESSOR_ARCHITECTURE%" == "AMD64" set PRUNSRV=prunsrv-amd64.exe
if "%PROCESSOR_ARCHITECTURE%" == "IA64" set PRUNSRV=prunsrv-ia64.exe

if "%1"=="install" goto installService
if "%1"=="uninstall" goto uninstallService

%JAVACMD% %JAVA_OPTS% %EXTRA_JVM_ARGUMENTS% -classpath %CLASSPATH_PREFIX%;%CLASSPATH% -Dapp.name="scm-server" -Dapp.repo="%REPO%" -Dbasedir="%BASEDIR%" sonia.scm.server.ScmServerDaemon %CMD_LINE_ARGS%
if ERRORLEVEL 1 goto error
goto end

:installService
"%BASEDIR%\libexec\%PRUNSRV%" //IS//scm-server --Classpath=%CLASSPATH_PREFIX%;%CLASSPATH% --JvmOptions=-Dapp.name="scm-server";-Dapp.repo="%REPO%";-Dbasedir="%BASEDIR%" ++JvmOptions=-Djava.awt.headless=true;-Dlogback.configurationFile=logging.xml --DisplayName="scm-server" --Jvm=auto --StartMode=jvm --StartMethod=start --StopMode=jvm --StopMethod=stop --StartClass=sonia.scm.server.ScmServerDaemon --StopClass=sonia.scm.server.ScmServerDaemon --LogPath="%BASEDIR%\var\log" --PidFile="%BASEDIR%\var\scm-server.pid"
if ERRORLEVEL 1 goto error
goto end

:uninstallService
"%BASEDIR%\libexec\%PRUNSRV%" //DS//scm-server
if ERRORLEVEL 1 goto error
goto end


:error
if "%OS%"=="Windows_NT" @endlocal
set ERROR_CODE=1

:end
@REM set local scope for the variables with windows NT shell
if "%OS%"=="Windows_NT" goto endNT

@REM For old DOS remove the set variables from ENV - we assume they were not set
@REM before we started - at least we don't leave any baggage around
set CMD_LINE_ARGS=
goto postExec

:endNT
@endlocal

:postExec

if "%FORCE_EXIT_ON_ERROR%" == "on" (
  if %ERROR_CODE% NEQ 0 exit %ERROR_CODE%
)

exit /B %ERROR_CODE%
